--[[
AoFDKP Fu  $Date: 2006-12-08 15:29:47 -0500 (Fri, 08 Dec 2006) $  
written by Laric/Stormrage(eu)
code based on GetDKP+ by Corgan.
--]]

-- LUA version detection
local lua51 = loadstring("return function(...) return ... end") and true or false

-- locals

local L         = AceLibrary("AceLocale-2.2"):new("aofdkp")
local Roster		= AceLibrary("RosterLib-2.0")

local chatprefix = "<AOFDKP>"

aofdkpsave = {}
aofdkptime = ""
-- Define the global addon variable
aofdkp = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceConsole-2.0", "AceDebug-2.0", "AceEvent-2.0", "AceDB-2.0", "AceHook-2.1", "AceComm-2.0")

aofdkp.defaultPosition = 'RIGHT'

-- Define the options table


-- Initialization event
function aofdkp:OnInitialize()
  if aofdkptime ~= DKPInfo.date then
    aofdkptime = DKPInfo.date
    aofdkpsave = gdkp
  end
	self.options = {
	  type="group",
	  args = {
	  	raidmem = {
	  	  type = "toggle",
	  	  name = "Raidmembers only",
	  	  desc = "Show only raidmembers in buy texts",
	  	  order = 1,
	  	  set = function() self.db.profile.raidmembers = not self.db.profile.raidmembers end,
	  	  get = function() return self.db.profile.raidmembers end,
	  	},
	  	addraidmem = {
	  	  type = "toggle",
	  	  name = "Add new raidmembers",
	  	  desc = "Add new raidmembers to the dkp tables.",
	  	  order = 1,
	  	  set = function() self.db.profile.addraidmembers = not self.db.profile.addraidmembers end,
	  	  get = function() return self.db.profile.addraidmembers end,
	  	},
	  	maxprebuy = {
	  		type = "range",
	  		name = "Max previous buyers",
	  		desc = "Maximum number of previous buyers in texts",
	  		order = 2,
	  		max = 15,
	  		min = 0,
	  		set = function(v) self.db.profile.maxprebuyers=v end,
	  		get = function() return self.db.profile.maxprebuyers end,
	  		step = 1,
	  	},
	  	maxbuy = {
	  		type = "range",
	  		name = "Max buyers",
	  		desc = "Maximum number of buyers in texts",
	  		order = 2,
	  		max = 15,
	  		min = 0,
	  		set = function(v) self.db.profile.maxbuyers=v end,
	  		get = function() return self.db.profile.maxbuyers end,
	  		step = 1,
	  	},
		  fubar = {
				type = "group",
				name = "FuBarPlugin Config",
				desc = "Configure the FuBar Plugin",
				args = {},
		    order = 999
			},
			shortcuts = {
				type = "execute",
				name = "Shortcuts",
				desc = "Prints the shortcuts help",
				func = function()
									self:shortcuthelp()
							 end
			}
	  }
  }
  
	self:SetDebugging(false)
	self:RegisterEvent("RosterLib_RosterChanged")
	self:RegisterDB("aofdkpdb")
	self:RegisterDefaults('profile',{	raidmembers = true, maxprebuyers = 10, maxbuyers = 10, addraidmembers = true	})
  self:RegisterChatCommand({"/aofdkp"}, self.options )
  self:RegisterShorthand("dkp-", function(cmd) self:dkpmath(true,cmd) end )
  self:RegisterShorthand("dkp+", function(cmd) self:dkpmath(false,cmd) end )
  self:RegisterShorthand("dkpshow", function(cmd) self:listdkp(cmd) end )
  self:RegisterShorthand("dkp", function(cmd) self:listdkp(cmd) end )
  self:RegisterShorthand("dkpalts", function(cmd) self:listalts(cmd) end )
  self:RegisterShorthand("dkpmain", function(cmd) self:listmain(cmd) end )
  self:RegisterShorthand("dkpitem", function(cmd) self:findbuyers(cmd) end )
  self:RegisterShorthand("item", function(cmd) self:findbuyers(cmd) end )
  self:SecureHook("ChatFrame_OnHyperlinkShow")
 	self:Hook("ChatFrame_MessageEventHandler", "WhisperHandler", true)
  self:RegisterEvent("CHAT_MSG_WHISPER")
  self:SetCommPrefix("AoFDKP")
  self:RegisterComm("AoFDKP", "RAID")
  self.OnMenuRequest = self.options
end


function aofdkp:WhisperHandler(event)
	if ( string.find(arg1,chatprefix ) ) then
		return
	end
	return self.hooks["ChatFrame_MessageEventHandler"](event)
end

function aofdkp:RegisterShorthand(shorthand, func)
	if shorthand and shorthand ~= "" then
		local type = "AOFDKP_SHORTHAND_"..strupper(shorthand)
		SlashCmdList[type] = func
		setglobal("SLASH_"..type.."1", "/"..strlower(shorthand))
	end
end


function aofdkp:shortcuthelp()
  self:Print("Shortcuts in AoFDKP")
  self:Print("/dkp- name num    substracts num dkp from player name")
  self:Print("/dkp+ name num    adds num dkp to player name")
  self:Print("/dkpshow name    shows the dkp of player name")
  self:Print("/dkpalts name    shows the alts of player name")
  self:Print("/dkpmain name    shows the main of player name")
  
end


function aofdkp:ChatFrame_OnHyperlinkShow(reference, link, button)
	local item = self:getitemname(link)
	if item then
	  for k,v in pairs(aofdkp_sets.items) do
	    if strlower(v.Name)==strlower(item) then
	      self:Print("Item: "..v.Name.." class: "..v.Class)
	    end
	  end
	end
end

-- Util functions

function aofdkp:OnCommReceive(prefix, sender, distribution, message)
    print("message from", sender, "-", message)
end



function aofdkp:RosterLib_RosterChanged(tbl)
  if aofdkpsave then
    if aofdkpsave.players then
		   	for name in pairs(tbl) do
					if aofdkpsave.players[name] then
						if tbl[name].class then
								aofdkpsave.players[name].class = string.upper(string.sub(tbl[name].class,1,1))..string.lower(string.sub(tbl[name].class,2))
						end
					else
					  -- Here we have new unknown player. Lets add him/her with 0 dkpmain. Only do this if we are in a raid and the option to do so is set.
					  if UnitInRaid("player") and self.db.profile.addraidmember then
						  aofdkpsave.players[name]={}
						  aofdkpsave.players[name].class = string.upper(string.sub(tbl[name].class,1,1))..string.lower(string.sub(tbl[name].class,2))
						  aofdkpsave.players[name].dkp = 0
						end
					end
        end
    end
  end
end


function aofdkp:getargs(message, separator)

	local args = {}
	local i = 0
	for value in string.gmatch(message, "[^"..separator.."]+") do
		i = i + 1
		args[i] = value
	end
	return args
end

function aofdkp:getclass(class)
  class=strlower(class)
  local players = {}
  local i=0
  self:Debug("In getclass again :"..class)
  for k,v in pairs(aofdkpsave.players) do
  	--self:Debug(v.class)
    if strlower(v.class) == class then
    	--if v.altof then
    	--	table.insert(players,v.altof)
    	--else
      	table.insert(players,k)
      --end
    end
  end
  return players
end

function aofdkp:inlist(check,list)
	for k,v in ipairs(list) do
	  if strlower(v)==strlower(check) then
	    return true
	  end
	end
  return false
end

function aofdkp:getmain(player) -- Returns players main player or nil
	player=string.upper(string.sub(player,1,1))..string.lower(string.sub(player,2))
  for k,v in pairs(aofdkpsave.players) do
    if k == player then
    	if v.altof then
    		return v.altof
    	else
      	return k
      end
    end
  end
  return nil
end

function aofdkp:output(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20)
 return self:Print(a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20)
end


function aofdkp:getitemname(item)

if item == nil then
return ""
end;
local iteminfo
local itemname
  self:Debug(item)
	--for iteminfo, itemname in string.gmatch(item, "|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h") do
	itemname, _= GetItemInfo(item)
	if itemname and itemname~="" then return itemname end
	
	return item;

end

-- DKP functions

function aofdkp:CHAT_MSG_WHISPER()
  local args = self:getargs(arg1," ")
  local sender = arg2
  local raidonly = false
  local cmd = ""
  if Roster:GetUnitObjectFromName(arg2) then raidonly = true end
  if args and args[1] and strlower(args[1]) == "dkp" then
    for k,v in ipairs(args) do
      if cmd ~= "" then cmd=cmd.." " end
      if strlower(v)~="dkp" and strlower(v)~="all" then
        cmd = cmd .. v
      end
      if strlower(v)=="all" then
        raidonly=false
      end
    end
    if cmd == "" then cmd = arg2 end
    local dkplist = self:builddkplist(cmd)
		for k,v in ipairs(dkplist) do
		  if raidonly then
				if Roster:GetUnitObjectFromName(v.name) then
					local name = self:getmain(v.name)
					if strlower(name) == strlower(v.name) then name= "" end
					if name ~= "" then
					  SendChatMessage(chatprefix.." "..v.name.." "..v.dkp.."  * Alt of "..name.."*","WHISPER",nil,arg2)
					else
				    SendChatMessage(chatprefix.." "..v.name.." "..v.dkp,"WHISPER",nil,arg2)
				  end
				end
			else
				local name = self:getmain(v.name)
				if strlower(name) == strlower(v.name) then name= "" end
				if name ~= "" then
				  SendChatMessage(chatprefix.." "..v.name.." "..v.dkp.."  * Alt of "..name.."*","WHISPER",nil,arg2)
				else
			    SendChatMessage(chatprefix.." "..v.name.." "..v.dkp,"WHISPER",nil,arg2)
			  end
			end			
		end  
  end
    
end


function aofdkp:findbuyers(cmd)
 if cmd and cmd ~= "" then
   local item = self:getitemname(cmd)
   local potbuyersfound = false
   self:Debug(item)
   local players = {}
   local class = ""
	 -- Find if the item is class bound
   for k,v in pairs(aofdkp_sets.items) do
     if strlower(v.Name) == strlower(item) then 
       class = v.Class
     end
   end
   for k,v in pairs(DKP_ITEMS) do
     local kname = string.upper(string.sub(k,1,1))..string.lower(string.sub(k,2))
     for k1,v1 in pairs(v.Items) do
       if strlower(item)==strlower(k1) then
         if aofdkpsave.players[kname] and aofdkpsave.players[kname].class and strlower(class)==strlower(aofdkpsave.players[kname].class) then
         	table.insert(players,k)
         	self:Debug("prebuyer: "..k)
         end
       end
     end
   end
   local classlist={}
   if class~="" then
     classlist = self:getclass(class)
   end
	 
	 local buyers={}
   for k,v in ipairs(classlist) do
   	 self:Debug(v)
     if not self:inlist(v,players) then
       table.insert(buyers,v)
     end
   end

   local dkplist=self:getdkplist(buyers)

   if self.db.profile.maxprebuyers>0 and table.getn(players)>0 then
     local counter=self.db.profile.maxprebuyers
     if table.getn(players)<counter then counter=table.getn(players) end
     self:Debug("MaxPre: " .. self.db.profile.maxprebuyers .. " Players: " ..table.getn(players).." Counter: "..counter)
     local cnt
     for cnt = 1,counter do
   		if UnitInRaid("player") then
		    if cnt==1 then SendChatMessage(table.getn(players).." previous buyers of "..item,"RAID") end
   		  SendChatMessage(string.upper(string.sub(players[cnt],1,1))..string.lower(string.sub(players[cnt],2)),"RAID")
	  	  self:Debug(cnt)
   		else
  		  if cnt==1 then self:Print(table.getn(players).." previous buyers of "..item) end
	  	  self:Print(string.upper(string.sub(players[cnt],1,1))..string.lower(string.sub(players[cnt],2)))
	  	  self:Debug(cnt)
   		end
     end
   else
   		if UnitInRaid("player") then
		    SendChatMessage(table.getn(players).." previous buyers of "..item,"RAID")
   		else
  		  self:Print(table.getn(players).." previous buyers of "..item)
   		end
   end


		if UnitInRaid("player") then
			for k,v in ipairs(dkplist) do
			  if self.db.profile.raidmembers then
					if Roster:GetUnitObjectFromName(v.name) then
						if not potbuyersfound then SendChatMessage("Potential buyers of "..item.." are as follows:","RAID") end
					  potbuyersfound = true
						local name = self:getmain(v.name)
						if strlower(name) == strlower(v.name) then name= "" end
						if name ~= "" then
						  SendChatMessage(v.name.." "..v.dkp.."  * Alt of "..name.."*","RAID")
						else
					    SendChatMessage(v.name.." "..v.dkp,"RAID")
					  end
					end
				else
					local name = self:getmain(v.name)
					if not potbuyersfound then SendChatMessage("Potential buyers of "..item.." are as follows:","RAID") end
					potbuyersfound = true
					if strlower(name) == strlower(v.name) then name= "" end
					if name ~= "" then
					  SendChatMessage(v.name.." "..v.dkp.."  * Alt of "..name.."*","RAID")
					else
				    SendChatMessage(v.name.." "..v.dkp,"RAID")
				  end
				end			
			end  
		else
			for k,v in ipairs(dkplist) do
				if not potbuyersfound then self:Print("Potential buyers of "..item.." are as follows:") end
			  potbuyersfound = true
				local name = self:getmain(v.name)
				if strlower(name) == strlower(v.name) then name= "" end
				if name ~= "" then
				  self:Print(v.name.." "..v.dkp.."  * Alt of "..name.."*")
				else
			    self:Print(v.name.." "..v.dkp)
			  end
			end  
		end

   if potbuyersfound==false then
		if UnitInRaid("player") then
		  SendChatMessage("No needers found for this item: "..item,"RAID")
		else
		  self:Print("No needers found for this item: "..item)		
		end   
   end 
  end
end


function aofdkp:dkpmath(minus,cmd)
 if cmd and cmd ~= "" then
  if minus then 
   args = self:getargs(cmd," ")
   if table.getn(args)~=2 then
      self:Print("Math error. Please provide the correct syntax: ".. cmd)
   else
     local player=self:getmain(args[1])
     local mathdkp=tonumber(args[2])
     if player and mathdkp then
       aofdkpsave.players[player].dkp=aofdkpsave.players[player].dkp-mathdkp
       if UnitInRaid("player") then
			 	SendChatMessage("Aofdkp reduced player "..player.." with "..mathdkp.." dkp.","RAID")
			 	self:SendCommMessage("RAID", "math", "sub", mathdkp, player) 
       else
       	self:Print("Aofdkp reduced player "..player.." with "..mathdkp.." dkp.")
       end
     end 
   end
 	else
   args = self:getargs(cmd," ")
   if table.getn(args)~=2 then
      self:Print("Math error. Please provide the correct syntax: ".. cmd)
   else
     local player=self:getmain(args[1])
     local mathdkp=tonumber(args[2])
     if player and mathdkp then
       aofdkpsave.players[player].dkp=aofdkpsave.players[player].dkp+mathdkp
       if UnitInRaid("player") then
			 	SendChatMessage("Aofdkp increased player "..player.." with "..mathdkp.." dkp.","RAID")
			 	self:SendCommMessage("RAID", "math", "add", mathdkp, player) 
			 else
         self:Print("Aofdkp increased player "..player.." with "..mathdkp.." dkp.")
       end
     end 
   end
 	end
 end
end

function aofdkp:listdkp(cmd)
	local dkplist = self:builddkplist(cmd)
	if UnitInRaid("player") then
		for k,v in ipairs(dkplist) do
		  if self.db.profile.raidmembers then
				if Roster:GetUnitObjectFromName(v.name) then
					local name = self:getmain(v.name)
					if strlower(name) == strlower(v.name) then name= "" end
					if name ~= "" then
					  SendChatMessage(v.name.." "..v.dkp.."  * Alt of "..name.."*","RAID")
					else
				    SendChatMessage(v.name.." "..v.dkp,"RAID")
				  end
				end
			else
				local name = self:getmain(v.name)
				if strlower(name) == strlower(v.name) then name= "" end
				if name ~= "" then
				  SendChatMessage(v.name.." "..v.dkp.."  * Alt of "..name.."*","RAID")
				else
			    SendChatMessage(v.name.." "..v.dkp,"RAID")
			  end
			end			
		end  
	else
		for k,v in ipairs(dkplist) do
			local name = self:getmain(v.name)
			if strlower(name) == strlower(v.name) then name= "" end
			if name ~= "" then
			  self:Print(v.name.." "..v.dkp.."  * Alt of "..name.."*")
			else
		    self:Print(v.name.." "..v.dkp)
		  end
		end  
	end
end


function aofdkp:builddkplist(cmd)
  args = self:getargs(cmd," ")
  local retval=self:getdkplist(args)
  return retval
end

function aofdkp:getdkplist(args)
  dkplist = {}
  local paladin
  local mage
  local druid
  local shaman
  local priest
  local warrior
  local hunter
  local warlock
  local rogue
  
  local players = {}
  local player
  
  for k,v in ipairs(args) do
  	if strlower(v)=="paladin" then
   	  paladin = self:getclass("paladin")
		elseif strlower(v)=="mage" then
   	  mage = self:getclass("mage")
		elseif strlower(v)=="druid" then
   	  druid = self:getclass("druid")
		elseif strlower(v)=="shaman" then
   	  shaman = self:getclass("shaman")
		elseif strlower(v)=="priest" then
   	  priest = self:getclass("priest")
		elseif strlower(v)=="warrior" then
   	  warrior = self:getclass("warrior")
		elseif strlower(v)=="hunter" then
   	  hunter = self:getclass("hunter")
		elseif strlower(v)=="warlock" then
   	  warlock = self:getclass("warlock")
		elseif strlower(v)=="rogue" then
   	  rogue = self:getclass("rogue")
   	else
   	  if v and (not self:inlist(v,players)) then 
   	    table.insert(players,v)
   	  end
   	end
  end
  
  if type(paladin) == "table" then
    for k,v in ipairs(paladin) do
      if (not self:inlist(v,players)) then
        table.insert(players,v)
      end
    end
  end
  
  if type(mage) == "table" then
    for k,v in ipairs(mage) do
      if (not self:inlist(v,players)) then
        table.insert(players,v)
      end
    end
  end
  
  if type(druid) == "table" then
    for k,v in ipairs(druid) do
      if (not self:inlist(v,players)) then
        table.insert(players,v)
      end
    end
  end
  
  if type(shaman) == "table" then
    for k,v in ipairs(shaman) do
      if (not self:inlist(v,players)) then
        table.insert(players,v)
      end
    end
  end
  
  if type(priest) == "table" then
    for k,v in ipairs(priest) do
      if (not self:inlist(v,players)) then
        table.insert(players,v)
      end
    end
  end
  
  if type(warrior) == "table" then
    for k,v in ipairs(warrior) do
      if (not self:inlist(v,players)) then
        table.insert(players,v)
      end
    end
  end
  
  if type(hunter) == "table" then
    for k,v in ipairs(hunter) do
      if (not self:inlist(v,players)) then
        table.insert(players,v)
      end
    end
  end
  
  if type(warlock) == "table" then
    for k,v in ipairs(warlock) do
      if (not self:inlist(v,players)) then
        table.insert(players,v)
      end
    end
  end
  
  if type(rogue) == "table" then
    for k,v in ipairs(rogue) do
      if (not self:inlist(v,players)) then
        table.insert(players,v)
      end
    end
  end
  

  args=players
  
  local i2=0
  for k,v in ipairs(args) do
	  local name = string.upper(string.sub(v,1,1))..string.lower(string.sub(v,2))
	  if aofdkpsave and aofdkpsave.players and aofdkpsave.players[name] then
	    --if aofdkpsave.players[name].altof then name = aofdkpsave.players[name].altof end
	    i2=i2+1
	    dkplist[i2]={}
	    dkplist[i2].name=name
	    if aofdkpsave.players[name].altof then
	      dkplist[i2].dkp=tonumber(aofdkpsave.players[aofdkpsave.players[name].altof].dkp)
	    else
	    	dkplist[i2].dkp=tonumber(aofdkpsave.players[name].dkp)
	    end
	  end
	end
	
	table.sort(dkplist,function(a,b) return a.dkp<b.dkp end)
--	for k,v in ipairs(dkplist) do
--		local name = self:getmain(v.name)
--		if strlower(name) == strlower(v.name) then name= "" end
--		if name ~= "" then
--		  self:Print(v.name.." "..v.dkp.."  * Alt of "..name.."*")
--		else
--	    self:Print(v.name.." "..v.dkp)
--	  end
--	end
	
	return dkplist
end

function aofdkp:listmain(cmd)
  local name = string.upper(string.sub(cmd,1,1))..string.lower(string.sub(cmd,2))
  local main = ""
  if aofdkpsave and aofdkpsave.players and aofdkpsave.players[name] then
    if aofdkpsave.players[name].altof then main = aofdkpsave.players[name].altof end
    if main ~= "" then
      self:Print(name.." is an alt of "..main)
    else
      self:Print(name .. " is a main")
    end
  end
end

function aofdkp:listalts(cmd)
  local name = string.upper(string.sub(cmd,1,1))..string.lower(string.sub(cmd,2))
  local alts = ""
  if aofdkpsave and aofdkpsave.players and aofdkpsave.players[name] then
		if aofdkpsave.players[name].alts then
			for k,v in pairs(aofdkpsave.players[name].alts) do
			  if alts == "" then
			    alts = k
			  else
			    alts = alts..", "..k
			  end
			end
			if alts ~= "" then
			  self:Print(name.."'s alts are: "..alts)
			else
				self:Print(name.." has no alts, or is an alt.")
			end			 
		else
			self:Print(name.." has no alts, or is an alt.")
		end
  end
end
